/*#declare Default =
	texture {
		pigment { rgb x }
		finish { ambient 1 }
	}*/

#declare Shorts =
	texture {
		pigment {
			pigment_pattern {
				average
				pigment_map {
					[1
						gradient z+x
						sine_wave
						scale .003
					]
					[1
						spotted scale .2
					]
				}
			}
			colour_map {
				[0 rgb <.5,.6,.7>]
				[1 rgb <.15,.2,.25>]
			}
		}
		finish { brilliance .5 }
		normal {
			gradient z+x
			sine_wave
			scale .01
		}
	}

#declare Shirt =
	texture {
		pigment {
			granite
			scale .1
			poly_wave 4
			colour_map {
				[0 rgb <.9,.9,.8>]
				[1 rgb <.7,.5,.3>]
			}
		}
		finish { brilliance .5 }
		normal {
			leopard -1
			scale .003
		}
	}

#declare InMouth =
	texture {
		pigment { rgb x/2 }
	}

#declare Eye =
	texture {
		pigment {
			slope { -z+x/2 }
      pigment_map {
      	[.5	granite scale .001 colour_map { [0 rgb x][1 rgb 1] }]
      	[.9	rgb 2]	//exagerate the contrast in his eyes.
      	[.9 rgb <.3,.6,.8>]///2+1/2]
      	[.96 rgb <.3,.6,.8>]///2+1/2]
      	[.96	rgb 1] //death rgb 0]
      }
		}
		finish {
			reflection .05
			phong 1 phong_size 500
		}
	}

#declare Hair =
	texture {
		pigment {
			/*granite
			scale <1,3,1>*.1
			warp { turbulence <.1,.5,.1> }*/
			spotted
			//turbulence <2,.3,2>
			scale .0007*<1,40,40>
			poly_wave 2
			colour_map {
				[0 rgb <.0,.05,.1>]
				[1 rgbt 1]
			}
		}
		finish {
			phong 1 phong_size 10
		}
		normal {
			spotted .3
			//turbulence <2,.3,2>
			scale .0007*<1,40,40>
		}
	}

#declare Skin =
	texture {
		pigment {
			crackle
			poly_wave 1/8
			scale .1
			colour_map {
/*			#local Tan=.1;
				[.05 rgb <.8,.8,.9>*(1-Tan)+<.4,.2,0>*Tan] //veins
				[1 rgb <1,.8,.7>*(1-Tan)+<.4,.2,0>*Tan] //<1,.85,.75>*/
				[0 rgb <.8,.8,.9>] //veins
				[1 rgb <.9,.65,.55>]//<.9,.65,.55>] //1,.7,.6 //a bit sunburnt
			}
		}
		finish { brilliance 1 phong .3 phong_size 5 metallic 1 } //brilliance .5 phong .5 phong_size 10 metallic 1 }
		normal {
			average
			normal_map {
				[1
					crackle -.4	//veins
					poly_wave 1/8
					scale .1
				]
				[1
					crackle .4	//cracked skin
					scale .008
					slope_map {
						[0 <0,0>]
						[.1 <1,1>]
						[.1 <1,0>]
						[1 <.5,0>]
					}
				]
			}
		}
	}
